%{!?python_sitelib: %define python_sitelib %(%{__python} -c "from distutils.sysconfig import get_python_lib; print get_python_lib()")}
%{!?pyver: %define pyver %(%{__python} -c "import sys ; print sys.version[:3]")}

Name:           moksha
Version:        1.0.0
Release:        18%{?dist}
Summary:        A platform for creating real-time web applications
License:        ASL 2.0
URL:            https://fedorahosted.org/moksha
Source0:        http://pypi.python.org/packages/source/m/%{name}/%{name}-%{version}.tar.gz
Source1:        %{name}.conf
Source2:        moksha-hub.service

Patch0:         0001-Fix-our-apache-config-for-2.4-rhbz-871430.patch

BuildArch:      noarch

BuildRequires:  python2-setuptools
BuildRequires:  python2-sphinx
BuildRequires:  python2-nose
BuildRequires:  python2-moksha-common
BuildRequires:  python2-moksha-hub
BuildRequires:  python2-moksha-wsgi
BuildRequires:  systemd

Requires(post): systemd
Requires(preun): systemd
Requires(postun): systemd

Requires:       python2-moksha-common
Requires:       python2-moksha-hub
Requires:       python2-moksha-wsgi

%description
Moksha is a platform for creating real-time collaborative web applications.  It 
provides a set of Python and JavaScript API's that make it simple to create 
rich applications that can acquire, manipulate, and visualize data from 
external services. It is a unified framework build using the best available 
open source technologies such as TurboGears2, jQuery, AMQP, and Orbited.

%package doc
Summary: Developer documentation for Moksha
Requires: %{name} = %{version}-%{release}

%description doc
This package contains developer documentation for Moksha along with
other supporting documentation

%package server
Summary: mod_wsgi Moksha server
Requires: %{name} = %{version}-%{release}
Requires: python2-mod_wsgi httpd


%description server
This package contains an Apache mod_wsgi configuration for Moksha.

%prep
%setup -q
%patch0 -p1 -b .rhbz871430

%build
%{__sed} -i -e 's/$VERSION/%{version}/g' docs/conf.py
make -C docs html
#%{__rm} docs/_build/html/.buildinfo

%install

%{__mkdir_p} %{buildroot}%{_datadir}/%{name}/production/apache
%{__mkdir_p} %{buildroot}%{_datadir}/%{name}/production/nginx
%{__mkdir_p} %{buildroot}%{_datadir}/%{name}/production/rabbitmq
%{__mkdir_p} %{buildroot}/run/%{name}
%{__mkdir_p} %{buildroot}%{_sysconfdir}/logrotate.d
%{__mkdir_p} %{buildroot}%{_prefix}/lib/tmpfiles.d
%{__mkdir_p} -m 0755 %{buildroot}/%{_localstatedir}/cache/%{name}
%{__mkdir_p} -m 0755 %{buildroot}/%{_localstatedir}/lib/%{name}
%{__mkdir_p} -m 0755 %{buildroot}%{_sysconfdir}/httpd/conf.d
%{__mkdir_p} -m 0755 %{buildroot}/%{_sysconfdir}/%{name}/
%{__mkdir_p} -m 0755 %{buildroot}/%{_sysconfdir}/%{name}/conf.d
%{__mkdir_p} -m 0755 %{buildroot}/%{_var}/log/%{name}

%{__install} -m 0644 production/*.* %{buildroot}%{_datadir}/%{name}/production/
%{__install} -m 0644 production/apache/* %{buildroot}%{_datadir}/%{name}/production/apache
%{__install} -m 0644 production/apache/moksha.conf %{buildroot}%{_sysconfdir}/httpd/conf.d/
%{__install} -m 0644 production/nginx/* %{buildroot}%{_datadir}/%{name}/production/nginx
%{__install} -m 0644 production/rabbitmq/*.patch %{buildroot}%{_datadir}/%{name}/production/rabbitmq
%{__install} -m 0755 production/rabbitmq/run %{buildroot}%{_datadir}/%{name}/production/rabbitmq
%{__install} -m 0644 production/logrotate/moksha %{buildroot}%{_sysconfdir}/logrotate.d/
%{__install} -p -D -m 0644 %{SOURCE1} %{buildroot}%{_prefix}/lib/tmpfiles.d/%{name}.conf
%{__install} -p -D -m 0644 %{SOURCE2} $RPM_BUILD_ROOT%{_unitdir}/moksha-hub.service

%{__cp} production/sample-production.ini %{buildroot}%{_sysconfdir}/%{name}/sample-production.ini
%{__cp} development.ini %{buildroot}%{_sysconfdir}/%{name}/development.ini
%{__cp} orbited.cfg %{buildroot}%{_sysconfdir}/%{name}/orbited.cfg

%{__sed} -i -e 's/$VERSION/%{version}/g' %{buildroot}%{_sysconfdir}/%{name}/sample-production.ini

%{__rm} %{buildroot}%{_datadir}/%{name}/production/moksha-hub.init

%post
%systemd_post moksha-hub.service

%post server
semanage fcontext -a -t httpd_cache_t '/var/cache/moksha(/.*)?'
restorecon -Rv /var/cache/moksha

%postun 
%systemd_postun

%pre
%{_sbindir}/groupadd -r %{name} &>/dev/null || :
%{_sbindir}/useradd  -r -s /sbin/nologin -d %{_datadir}/%{name} -M \
                           -c 'Moksha' -g %{name} %{name} &>/dev/null || :

%preun
%systemd_preun moksha-hub.service

%triggerun -- moksha < 1.0.0-5
# Save the current service runlevel info
# User must manually run systemd-sysv-convert --apply moksha-hub
# and systemd-sysv-convert --apply moksha-hub
# to migrate them to systemd targets
/usr/bin/systemd-sysv-convert --save moksha-hub >/dev/null 2>&1 ||:

# Run these because the SysV package being removed won't do them
/sbin/chkconfig --del moksha-hub >/dev/null 2>&1 || :
/bin/systemctl try-restart moksha-hub >/dev/null 2>&1 || :


%files 
%doc README AUTHORS COPYING
%dir /run/%{name}/
%{_prefix}/lib/tmpfiles.d/%{name}.conf
%{_unitdir}/moksha-hub.service
%attr(-,apache,apache) %dir %{_localstatedir}/lib/%{name}
%attr(0755,root,%{name}) %dir %{_var}/log/%{name}
%config(noreplace) %{_sysconfdir}/logrotate.d/%{name}

%files server
%attr(-,apache,root) %{_datadir}/%{name}
%config(noreplace) %{_sysconfdir}/httpd/conf.d/moksha.conf
%config(noreplace) %{_sysconfdir}/%{name}/*.ini
%config(noreplace) %{_sysconfdir}/%{name}/orbited.cfg
%attr(-,apache,apache) %dir %{_localstatedir}/cache/%{name}/

%files doc
%doc docs/_build/html

%changelog
* Fri Feb 01 2019 Fedora Release Engineering <releng@fedoraproject.org> - 1.0.0-18
- Rebuilt for https://fedoraproject.org/wiki/Fedora_30_Mass_Rebuild

* Fri Jul 13 2018 Fedora Release Engineering <releng@fedoraproject.org> - 1.0.0-17
- Rebuilt for https://fedoraproject.org/wiki/Fedora_29_Mass_Rebuild

* Mon Mar 19 2018 Iryna Shcherbina <ishcherb@redhat.com> - 1.0.0-16
- Update Python 2 dependency declarations to new packaging standards
  (See https://fedoraproject.org/wiki/FinalizingFedoraSwitchtoPython3)

* Thu Feb 08 2018 Fedora Release Engineering <releng@fedoraproject.org> - 1.0.0-15
- Rebuilt for https://fedoraproject.org/wiki/Fedora_28_Mass_Rebuild

* Wed Jul 26 2017 Fedora Release Engineering <releng@fedoraproject.org> - 1.0.0-14
- Rebuilt for https://fedoraproject.org/wiki/Fedora_27_Mass_Rebuild

* Wed Apr 12 2017 Randy Barlow <bowlofeggs@fedoraproject.org> - 1.0.0-13
- Drop the requirement on python-orbited as it is no longer required (#1430463).

* Fri Feb 10 2017 Fedora Release Engineering <releng@fedoraproject.org> - 1.0.0-12
- Rebuilt for https://fedoraproject.org/wiki/Fedora_26_Mass_Rebuild

* Thu Feb 04 2016 Fedora Release Engineering <releng@fedoraproject.org> - 1.0.0-11
- Rebuilt for https://fedoraproject.org/wiki/Fedora_24_Mass_Rebuild

* Wed Jun 17 2015 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.0.0-10
- Rebuilt for https://fedoraproject.org/wiki/Fedora_23_Mass_Rebuild

* Sat Jun 07 2014 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.0.0-9
- Rebuilt for https://fedoraproject.org/wiki/Fedora_21_Mass_Rebuild

* Tue Aug 06 2013 Ralph Bean <rbean@redhat.com> - 1.0.0-8
- Added BuildRequires systemd.

* Sat Aug 03 2013 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.0.0-7
- Rebuilt for https://fedoraproject.org/wiki/Fedora_20_Mass_Rebuild

* Wed Feb 20 2013 Jóhann B. Guðmundsson <johannbg@fedoraproject.org> - 1.0.0-6
- Inital systemd support

* Thu Feb 14 2013 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.0.0-5
- Rebuilt for https://fedoraproject.org/wiki/Fedora_19_Mass_Rebuild

* Tue Jan 08 2013 Luke Macken <lmacken@redhat.com> - 1.0.0-4
- Fix our apache config for 2.4 (#871430)

* Wed Sep 19 2012 Ralph Bean <rbean@redhat.com> - 1.0.0-3
- Removed old sitelib ownership now owned by python-moksha-common.

* Wed Sep 19 2012 Ralph Bean <rbean@redhat.com> - 1.0.0-2
- Added forgotten source.
- Removed setuptools commands that are no longer relevant.

* Tue Sep 04 2012 Ralph Bean <rbean@redhat.com> - 1.0.0-1
- Removed unnecessary defattrs and clean section.
- New upstream release as a meta package.

* Thu Aug 30 2012 Ralph Bean <rbean@redhat.com> - 0.8.8-4
- Add python-bunch in the requires list.

* Thu Aug 02 2012 Ralph Bean <rbean@redhat.com> - 0.8.8-3
- Re-added python-repoze-what to the Requires list.

* Thu Jul 19 2012 Ralph Bean <rbean@redhat.com> - 0.8.8-2
- Patch for ssl-enabled websocket client.

* Tue Jul 17 2012 Ralph Bean <rbean@redhat.com> - 0.8.8-1
- Security fix for websockets.
- Bugfix for txzmq subscription.

* Thu Jun 21 2012 Ralph Bean <rbean@redhat.com> - 0.8.6-1
- Per-consumer validation hooks.

* Mon Jun 18 2012 Ralph Bean <rbean@redhat.com> - 0.8.5-1
- Removed setuptools requirement of certain webob version.

* Mon Jun 11 2012 Ralph Bean <rbean@redhat.com> - 0.8.4-1
- Avoid setting up the reactor at import time.  Bugfix for daemonization.

* Mon Jun 11 2012 Ralph Bean <rbean@redhat.com> - 0.8.3-1
- Enhancement - allow override of entry-point listed consumers and producers.

* Mon Jun 11 2012 Ralph Bean <rbean@redhat.com> - 0.8.2-1
- Bugfix for zeromq hub: resolve hostnames to ip addresses on bind.
- Re-included orbited as a requirement.

* Wed Jun 06 2012 Ralph Bean <rbean@redhat.com> - 0.8.1-2
- No longer remove tests so fedmsg can use them.

* Wed Jun 06 2012 Ralph Bean <rbean@redhat.com> - 0.8.1-1
- Bugfix for zeromq consumers.

* Tue May 29 2012 Ralph Bean <rbean@redhat.com> - 0.8.0-4
- Remove setuptools requirement of orbited.

* Thu May 24 2012 Ralph Bean <rbean@redhat.com> - 0.8.0-3
- Conditional inclusion of repoze.what for el6

* Wed May 23 2012 Ralph Bean <rbean@redhat.com> - 0.8.0-2
- Added dependency on python-webhelpers
- Added dependency on python-webtest
- Updated version of dependency on python-txzmq

* Wed May 23 2012 Ralph Bean <rbean@redhat.com> - 0.8.0-1
- Bumped version to latest no-turbogears moksha.

* Mon May 14 2012 Ralph Bean <rbean@redhat.com> - 0.7.1-3
- Only removing check in the case of el6.

* Mon May 14 2012 Ralph Bean <rbean@redhat.com> - 0.7.1-2
- Commented check section out.  Tests fail due to a RHEL bug with repoze.

* Sat Apr 14 2012 Ralph Bean <rbean@redhat.com> - 0.7.1-1
- New version with zeromq and tw2.

* Thu Feb 09 2012 Luke Macken <lmacken@redhat.com> - 0.6.0-2
- Remove the pyevent requirement

* Fri Aug 19 2011 Luke Macken <lmacken@redhat.com> - 0.6.0-1
- 0.6.0 release
- Update our dependencies to finally get the test suite running
- Improve how we run our unit tests, to get them working on RHEL5

* Tue Feb 08 2011 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.5.0-5
- Rebuilt for https://fedoraproject.org/wiki/Fedora_15_Mass_Rebuild

* Wed Dec 15 2010 Luke Macken <lmacken@redhat.com> - 0.5.0-4
- Add a logrotate configuration

* Tue Dec 14 2010 Luke Macken <lmacken@redhat.com> - 0.5.0-3
- Handle ghosting /var/run/moksha
- Setup a log directory
- Get the moksha-hub init script working properly
- A variety of specfile cleanups from our package review (#661902)

* Fri Dec 10 2010 Luke Macken <lmacken@redhat.com> - 0.5.0-2
- Fix our Source URL
- Fix files-attr-not-set rpmlint errors
- Fix up the description
- Remove redundant license

* Sat Sep 11 2010 Luke Macken <lmacken@redhat.com> - 0.5.0-1
- 0.5.0 release
- Run the full test suite

* Thu Sep 24 2009 Luke Macken <lmacken@redhat.com> - 0.4.0-1
- 0.4.0 release

* Tue Sep 22 2009 Luke Macken <lmacken@redhat.com> - 0.3.5-1
- 0.3.5

* Sat Aug 29 2009 Luke Macken <lmacken@redhat.com> - 0.3.4-1
- Add a moksha-hub subpackage

* Mon Aug 24 2009 Luke Macken <lmacken@redhat.com> - 0.3.3-1
- Include our orbited configuration file in the moksha-server subpackage
- Create a /etc/moksha/conf.d for our app configs

* Sat Aug 22 2009 Luke Macken <lmacken@redhat.com> - 0.3.2-1
- Update to 0.3.2

* Sat Aug 15 2009 Luke Macken <lmacken@redhat.com> - 0.3.1-2
- Break out the mod_wsgi configuration into a moksha-server subpackage.

* Fri Aug 14 2009 Luke Macken <lmacken@redhat.com> - 0.3.1-1
- 0.3.1

* Mon Aug 03 2009 Luke Macken <lmacken@redhat.com> - 0.3-1
- 0.3, bugfix release

* Wed Jun 03 2009 Luke Macken <lmacken@redhat.com> - 0.2-1
- Add nose to the build requirements

* Wed May 27 2009 John (J5) Palmieri <johnp@redhat.com> - 0.1-0.1
- first package

